spot 2.3.4

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Modules Pages
Classes | Public Types | Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | List of all members
spot::couvreur99_check_shy Class Referencefinal
TωA (Transition-based ω-Automata) » TωA algorithms » Emptiness-checks » Emptiness-check algorithms

A version of spot::couvreur99_check that tries to visit known states first. More...

`#include <spot/twaalgos/gtec/gtec.hh>`

Inheritance diagram for spot::couvreur99_check_shy:
Collaboration diagram for spot::couvreur99_check_shy:

## Classes
struct | successor
struct | todo_item

## Public Types
typedef unsigned(unsigned_statistics::* | unsigned_fun )() const
typedef std::map< const char *, unsigned_fun, char_ptr_less_than > | stats_map

## Public Member Functions
| couvreur99_check_shy (const const_twa_ptr &a, option_map o=option_map())
virtual emptiness_check_result_ptr | check () override
| Check whether the automaton's language is empty. More...
virtual std::ostream & | print_stats (std::ostream &os) const override
| Print statistics, if any. More...
std::shared_ptr< const couvreur99_check_status > | result () const
| Return the status of the emptiness-check. More...
const const_twa_ptr & | automaton () const
| The automaton that this emptiness-check inspects. More...
const option_map & | options () const
| Return the options parametrizing how the emptiness check is realized. More...
const char * | parse_options (char *options)
| Modify the algorithm options. More...
virtual bool | safe () const
| Return false iff accepting_run() can return 0 for non-empty automata. More...
virtual const unsigned_statistics * | statistics () const
| Return statistics, if available. More...
virtual const ec_statistics * | emptiness_check_statistics () const
| Return emptiness check statistics, if available. More...
virtual void | options_updated (const option_map &old)
| Notify option updates. More...
void | set_states (unsigned n)
void | inc_states ()
void | inc_transitions ()
void | inc_depth (unsigned n=1)
void | dec_depth (unsigned n=1)
unsigned | states () const
unsigned | transitions () const
unsigned | max_depth () const
unsigned | depth () const
unsigned | get (const char *str) const

## Public Attributes
stats_map | stats

## Protected Types
typedef std::list< successor > | succ_queue
typedef std::list< todo_item > | todo_list

## Protected Member Functions
void | clear_todo ()
void | dump_queue (std::ostream &os=std::cerr)
| Dump the queue for debugging. More...
void | remove_component (const state *start_delete)
| Remove a strongly component from the hash. More...
unsigned | get_removed_components () const
unsigned | get_vmsize () const

## Protected Attributes
std::stack< acc_cond::mark_t > | arc
int | num
succ_queue::iterator | pos
todo_list | todo
bool | group_
| Whether successors should be grouped for states in the same SCC. More...
bool | group2_
std::shared_ptr < couvreur99_check_status > | ecs_
bool | poprem_
| Whether to store the state to be removed. More...
unsigned | removed_components
| Number of dead SCC removed by the algorithm. More...
const_twa_ptr | a_
| The automaton. More...
option_map | o_
| The options. More...

## Detailed Description

A version of spot::couvreur99_check that tries to visit known states first.

See the documentation for spot::couvreur99.

## Member Function Documentation

const const_twa_ptr& spot::emptiness_check::automaton | ( |  | ) | const
| inline inherited

The automaton that this emptiness-check inspects.

virtual emptiness_check_result_ptr spot::couvreur99_check_shy::check | ( |  | ) |
| override virtual

Check whether the automaton's language is empty.

Reimplemented from spot::couvreur99_check.

void spot::couvreur99_check_shy::dump_queue | ( | std::ostream & | os = `std::cerr` | ) |
| protected

Dump the queue for debugging.

virtual const ec_statistics* spot::emptiness_check::emptiness_check_statistics | ( |  | ) | const
| virtual inherited

Return emptiness check statistics, if available.

const option_map& spot::emptiness_check::options | ( |  | ) | const
| inline inherited

Return the options parametrizing how the emptiness check is realized.

virtual void spot::emptiness_check::options_updated | ( | const option_map & | old | ) |
| virtual inherited

Notify option updates.

const char* spot::emptiness_check::parse_options | ( | char * | options | ) |
| inherited

Modify the algorithm options.

virtual std::ostream& spot::couvreur99_check::print_stats | ( | std::ostream & | os | ) | const
| override virtual inherited

Print statistics, if any.

Reimplemented from spot::emptiness_check.

void spot::couvreur99_check::remove_component | ( | const state * | start_delete | ) |
| protected inherited

Remove a strongly component from the hash.

This function remove all accessible state from a given state. In other words, it removes the strongly connected component that contains this state.

std::shared_ptr<const couvreur99_check_status> spot::couvreur99_check::result | ( |  | ) | const
| inherited

Return the status of the emptiness-check.

When check() succeed, the status should be passed along to spot::counter_example.

This status should not be deleted, it is a pointer to a member of this class that will be deleted when the couvreur99 object is deleted.

virtual bool spot::emptiness_check::safe | ( |  | ) | const
| virtual inherited

Return false iff accepting_run() can return 0 for non-empty automata.

virtual const unsigned_statistics* spot::emptiness_check::statistics | ( |  | ) | const
| virtual inherited

Return statistics, if available.

## Member Data Documentation

const_twa_ptr spot::emptiness_check::a_
| protected inherited

The automaton.

bool spot::couvreur99_check_shy::group_
| protected

Whether successors should be grouped for states in the same SCC.

option_map spot::emptiness_check::o_
| protected inherited

The options.

bool spot::couvreur99_check::poprem_
| protected inherited

Whether to store the state to be removed.

unsigned spot::couvreur99_check::removed_components
| protected inherited

Number of dead SCC removed by the algorithm.

The documentation for this class was generated from the following file:

- spot/twaalgos/gtec/gtec.hh

Please direct any question, comment, or bug report to the Spot mailing list at spot@lrde.epita.fr.